--
-- ArcusinAutoStack
-- Class for all ArcusinAutoStacks
--
-- @author  Michael B.(Micha381 1.LS Modschiede)
-- @warning: do dont change this script or copy! 
-- @date  31/05/09


ArcusinAutoStack = {};

function ArcusinAutoStack.prerequisitesPresent(specializations)

    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function ArcusinAutoStack:load(xmlFile)    
	 self.create1 = SpecializationUtil.callSpecializationsFunction("create1");
	 self.loadItems = SpecializationUtil.callSpecializationsFunction("loadItems");
	 self.TischKippen = SpecializationUtil.callSpecializationsFunction("TischKippen");
	 self.Entladen = SpecializationUtil.callSpecializationsFunction("Entladen");
	 
	 self.stuetze = Utils.indexToObject(self.rootNode, "7")
	 self.itemsToSave ={}
	 self.fillLevel = 0
	
	local numrotationParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rotationParts#count"), 0);
	  self.rotationParts = {};
	  for i=1, numrotationParts do
	  local partnamei = string.format("vehicle.rotationParts.rotationPart".."%d",i);
	  local partindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	  if partindex ~= nil then
	  self.rotationParts[i] = {};
      self.rotationParts[i].node = partindex;
	  local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#minRot"));
	  self.rotationParts[i].minRot = {};
      self.rotationParts[i].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.rotationParts[i].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.rotationParts[i].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
	  
      x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#maxRot"));
	  self.rotationParts[i].maxRot = {};
      self.rotationParts[i].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.rotationParts[i].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.rotationParts[i].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
	  
      self.rotationParts[i].rotTime = Utils.getNoNil(getXMLString(xmlFile,  partnamei .. "#rotTime"), 2)*1000;
	 
	end;
	end;
	
	
	local numtranslationParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.translationParts#count"), 0);
	self.translationParts = {};
	for i=1, numtranslationParts do
	  local partnamei = string.format("vehicle.translationParts.translationPart".."%d",i);
	  local partindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	  if partindex ~= nil then
        self.translationParts[i] = {};
		self.translationParts[i].defaults ={}
        self.translationParts[i].node = partindex;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#minTrans"));
		self.translationParts[i].defaults.minTrans = {};
        self.translationParts[i].defaults.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationParts[i].defaults.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationParts[i].defaults.minTrans[3] = Utils.getNoNil(z, 0);
        self.translationParts[i].minTrans = {} 
        self.translationParts[i].minTrans[1] = Utils.getNoNil(x, 0);
        self.translationParts[i].minTrans[2] = Utils.getNoNil(y, 0);
        self.translationParts[i].minTrans[3] = Utils.getNoNil(z, 0);
		x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#maxTrans"));
		self.translationParts[i].defaults.maxTrans = {};
        self.translationParts[i].defaults.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationParts[i].defaults.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationParts[i].defaults.maxTrans[3] = Utils.getNoNil(z, 0);
		self.translationParts[i].maxTrans = {} 
        self.translationParts[i].maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationParts[i].maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationParts[i].maxTrans[3] = Utils.getNoNil(z, 0);
		self.translationParts[i].defaults.transTime = Utils.getNoNil(getXMLString(xmlFile, partnamei .. "#transTime"), 2)*1000;
		self.translationParts[i].transTime = Utils.getNoNil(getXMLString(xmlFile, partnamei .. "#transTime"), 2)*1000;
		
        end;
    end;
	
	
	local numAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Attachers#count"), 0);
	
     self.Attacher = {};
	
	for i=1, numAttachers do
	 local objectAttacher = {};
	 self.Attacher[i] = {};
	 local partnamei = string.format("vehicle.Attachers.objectAttacher".."%d",i);
	 objectAttacher.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 objectAttacher.joint = 0;
	 self.Attacher[i].object = {}; 
	 self.Attacher[i].object = objectAttacher;
	 self.Attacher[i].attachedObject = {}
	 for x=1,4 do
	 self.Attacher[i].attachedObject[x] = nil;
	 end;
	 self.Attacher[i].count = 0;
	 self.Attacher[i].objectAttachable = false;
	 self.Attacher[i].objectInRange = nil;
	end;
	
	local numHelpers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.HelperPoints#count"), 0);
	self.helper = {};
	for i=1, numHelpers do
	 local partnamei = string.format("vehicle.HelperPoints.helper".."%d",i);
	 self.helper[i] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	end;	
    self.Sounds = {{},{},{}};
	local FieldWorkSound = getXMLString(xmlFile, "vehicle.fieldWorkSound#file");
    if FieldWorkSound ~= nil and FieldWorkSound ~= "" then
        FieldWorkSound = Utils.getFilename(FieldWorkSound, self.baseDirectory);
		self.Sounds[3].sample = createSample("FieldWorkSound");
        loadSample(self.Sounds[3].sample, FieldWorkSound, false);
        local pitch = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fieldWorkSound#pitchOffset"), 0);
        self.Sounds[3].volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fieldWorkSound#volume"), 1.0);
        setSamplePitch(self.Sounds[3].sample, pitch);
		self.Sounds[3].Enabled = false;
		
    end;
        
    local hydraulicUpSound = getXMLString(xmlFile, "vehicle.hydraulicUpSound#file");
    local volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicUpSound#volume"), 1.0);
	if hydraulicUpSound ~= nil and hydraulicUp ~= "" then
        hydraulicUpSound = Utils.getFilename(hydraulicUpSound, self.baseDirectory); 
        self.Sounds[1].sample = createSample("hydraulicUpSound");
        loadSample(self.Sounds[1].sample, hydraulicUpSound, false);
        local pitch = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicUpSound#pitchOffset"), 0)
        setSamplePitch(self.Sounds[1].sample, pitch);
		self.Sounds[1].volume = volume
		self.Sounds[1].enabled = false
    end;

    local hydraulicDownSound = getXMLString(xmlFile, "vehicle.hydraulicDownSound#file");
    local volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicDownSound#volume"), 1.0);
   if hydraulicDownSound ~= nil and hydraulicDownSound ~= "" then
        hydraulicDownSound = Utils.getFilename(hydraulicDownSound, self.baseDirectory); 
        self.Sounds[2].sample = createSample("hydraulicDownSound");
        loadSample(self.Sounds[2].sample, hydraulicDownSound, false);
        local pitch = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicDownSound#pitchOffset"), 0)
        setSamplePitch(self.Sounds[2].sample, pitch);
		self.Sounds[2].volume = volume
		self.Sounds[2].enabled = false
    end;
	
	self.strawParticleSystems = {};
    local psName = "vehicle.strawParticleSystem";
    Utils.loadParticleSystem(xmlFile, self.strawParticleSystems, psName, self.components, false, nil, getAppBasePath())
    self.groundParticleSystemActive = false;
	
	
	
	end;

function ArcusinAutoStack:delete()
    Utils.deleteParticleSystem(self.strawParticleSystems);
	
	for i=1,3 do
	if self.Sounds[i].sample ~= nil then
	delete(self.Sounds[i].sample)
	end;end
end;

function ArcusinAutoStack:mouseEvent(posX, posY, isDown, isUp, button)
    
end;

function ArcusinAutoStack:draw()
	
	if self.attacherVehicle and not self.entladen then
	
		if self.down then
			g_currentMission:addExtraPrintText("Taste K: Transport Modus");
		else
			g_currentMission:addExtraPrintText("Taste K: Arbeits Modus");
		end; 
	end; 
	if self.lfheben == "fertig" and self.entladen then
	   g_currentMission:addExtraPrintText("Taste N: Ladeflchen senken");
	   end
	
	
	if self.fillLevel > 0 and self.down then
	if not self.entladen then
	g_currentMission:addExtraPrintText("Taste N: Ballen entladen");
	end;end
	
	if self.lfheben ~= "bereit" and self.fillLevel ~= 0 and self.entladen then
	       if self.lfheben ~= "abort" then
	        g_currentMission:addExtraPrintText("Tisch wird gekippt");
           else
           	g_currentMission:addExtraPrintText("Tisch wird gesenkt");
           end			
		end
		

	
	if self.lfheben == "bereit" then
	        g_currentMission:addExtraPrintText("Taste N: Ballen hier Entladen");
		    g_currentMission:addExtraPrintText("Taste O: Entladen abbrechen");
	end; 
	end


function ArcusinAutoStack:keyEvent(unicode, sym, modifier, isDown)
		
	if isDown and sym == Input.KEY_o then
		if self.down == true then
	    end
	end; 

	
	
	
    if isDown and sym == Input.KEY_n  then
	if self.entladen then 
	    if     self.lfheben == "bereit" then self.lfheben = "unlink"
		elseif self.lfheben == "fertig" then self.lfheben = "senken"
		end
	elseif self.fillLevel ~= 0 and self.down then 
	  self.entladen = true
	  if not self.lfheben then self.lfheben = "transfer";end
	end;end
	
	if isDown and sym == Input.KEY_o and self.lfheben == "bereit" then
	self.lfheben = "abort"
	end
	
	if isDown and sym == Input.KEY_k and not self.entladen then
		self.pickup = true
		self.zange = true 
		
	end; 
	


	
end;


function ArcusinAutoStack:update(dt)


if self.Sounds[1].sample ~= nil and self.Sounds[2].sample and self.sound1  then
                    playSample(self.Sounds[2].sample, 0, self.Sounds[2].volume, 0);
					playSample(self.Sounds[1].sample, 0, self.Sounds[1].volume, 0);
					self.Sounds[2].enabled = true;
					self.Sounds[1].enabled = true;
					
else               
                stopSample(self.Sounds[2].sample);
				 stopSample(self.Sounds[1].sample);
                self.Sounds[2].enabled = false;
				self.Sounds[1].enabled = false;
end
 if self.Sounds[2].sample and self.sound2  then
                    playSample(self.Sounds[2].sample, 0, 2.5, 0);
					self.Sounds[2].enabled = true;
					
else               
                stopSample(self.Sounds[2].sample);
                self.Sounds[2].enabled = false;
end 

if self.Sounds[3].sample ~= nil and not self.Sounds[3].enabled and self.sound3 then

			

					playSample(self.Sounds[3].sample, 1, self.Sounds[3].volume, 0);
			
					self.Sounds[3].enabled = true;
					self.sound3 = nil
					self.Sounds[3].Time = 0
else               
                self.Sounds[3].enabled = false;
end		

if self.ps1On and not self.strawParticleSystemActive then
          self.Time = 0 
		  self.strawParticleSystemActive = true;
          Utils.setEmittingState(self.strawParticleSystems, true);
		  
elseif self.strawParticleSystemActive then
       self.Time = self.Time + dt
	   if self.Time > 600 then
	      self.strawParticleSystemActive = false;
          Utils.setEmittingState(self.strawParticleSystems, false);
          self.ps1On = nil; self.Time = nil	   
	   end
end

	
	if self.st ~= nil then 
	    local kk = Move(self,dt,self.st,3)
	if kk == self.st then self.st = nil; end
	end; 
	
 	if self.attacherVehicle ~= nil then	
	
 if self.entladen then
	local tempNode
	if self.lfheben == "transfer" then
	    if self.Attacher[11].count ~=0 then 
	       self.transfer = true; 
	    elseif type(self.kipp) ~= "table" then
		 for i=2,10 do
		 local rotNode = self.rotationParts[7].node
		 local count = self.Attacher[i].count
		 local node = self.Attacher[i].object.node
		 local parent = getParent(node)
			if count ~= 0 and parent == rotNode then
			 for x=1,15 do
			 jointNode = self.translationParts[x].node
			 if jointNode == node then tempNode = x;break;end
			end;
			break;
			end
		
		  end
		if tempNode then self.kipp ={false,tempNode}; 
		elseif tempNode == nil then
		 self.kipp = "moveDown"
		 local check = Rotate(self,dt,true,3)
		 Rotate(self,dt,true,7)
		 if check  then self.lfheben = "set" ;end
		end
		
		end
	elseif self.lfheben == "set" then
		local node = self.translationParts[15].node
		local x,y,z = getTranslation(node)
		self.rotationParts[4].maxRot[1] = self.rotationParts[4].maxRot[1]/3
		self.rotationParts[8].maxRot[1] = self.rotationParts[8].maxRot[1]/3
		self.rotationParts[8].rotTime = self.rotationParts[8].rotTime/3
		self.rotationParts[4].rotTime = self.rotationParts[4].rotTime/3
		self.translationParts[15].minTrans[3] = z
		self.translationParts[15].maxTrans[3] = 0
		local zeit = Time(self,15,3)
		self.translationParts[15].transTime = zeit
		node = self.translationParts[2].node
		x,y,z = getTranslation(node)
		self.translationParts[2].minTrans[3] = z
		self.translationParts[2].maxTrans[3] = -0.907
		self.translationParts[2].transTime = zeit
		self.lfheben = "heben1"
	elseif self.lfheben == "heben1" then
		local kk = Rotate(self,dt,true,4)
		local ll = Rotate(self,dt,true,8)
			if kk and ll then
	        self.lfheben ="move1"
			end;
	elseif self.lfheben == "set2" then
	    self.translationParts[2].minTrans[3] = 5.37
		self.translationParts[2].transTime = 5000
		self.rotationParts[4].maxRot[1] = self.rotationParts[4].maxRot[1]*3
		self.rotationParts[8].maxRot[1] = self.rotationParts[8].maxRot[1]*3
		self.rotationParts[8].rotTime = self.rotationParts[8].rotTime*3
		self.rotationParts[4].rotTime = self.rotationParts[4].rotTime*3
	    self.lfheben = "move2"
	elseif self.lfheben == "move1" then
		local check = Move(self,dt,true,15)
		Move(self,dt,true,2)
	    if check then self.lfheben = "set2";self.zange=true ;end
	elseif self.lfheben == "move2" then
		Rotate(self,dt,true,9)
		local x,y,z = getRotation(self.rotationParts[9].node)
		if x < -0.8 then Move(self,dt,false,2);end
		x,y,z = getTranslation(self.translationParts[2].node)
		if z > 0.5 then 
		              Rotate(self,dt,true,4)
		local check = Rotate(self,dt,true,8)
		if check then self.lfheben = "bereit" ;end
		end
	elseif self.lfheben == "unlink" then
		local nodes ={}
		local count
		local node
		local child
		for i=1,9 do
		 local x = getNumOfChildren(self.helper[i])
		  if x ~= 0 then
		   node = getChildAt(self.helper[i],0)
		   count = getNumOfChildren(node)
		   table.insert(nodes,{["node"]=node,["count"]=count})
		  end;
		end
	    self:Entladen(dt,nodes,1)
		self.zange = true
		self.lfheben = "fertig"
	elseif self.lfheben == "fertig" then
		Rotate(self,dt,false,3)
		Rotate(self,dt,false,7)
	
	elseif self.lfheben == "abort" then
        Rotate(self,dt,false,4)
		local check = Rotate(self,dt,false,8)
        if not check then
		self.entladen = nil;
		self.lfheben = nil;
		self.fillLevel = 36;
		end;
			
	elseif self.lfheben == "senken" then
        Move(self,dt,false,2)
		Rotate(self,dt,false,4)
		local check = Rotate(self,dt,false,8)
		if not check then
			for i=1,table.getn(self.translationParts) do
				self.translationParts[i].transTime = self.translationParts[i].defaults.transTime
				for x=1,3 do
				self.translationParts[i].minTrans[x] = self.translationParts[i].defaults.minTrans[x]
				self.translationParts[i].maxTrans[x] = self.translationParts[i].defaults.maxTrans[x]
				end;end
			local minRot = self.translationParts[15].minTrans
			setTranslation(self.translationParts[15].node,unpack(minRot))
			local check = Rotate(self,dt,false,9)
			if not check then self.entladen = nil; self.lfheben = nil;end
		end

	
	end
        
 end

	if self.down and not self.arm and not self.transfer and not self.kipp and not self.schieber and not self.entladen and self.fillLevel < 36 then
	self.on = true
	else 
	self.on = false
	end
	
	

	if self.zange then
	   if self.zangeMove then
	               Rotate(self,dt,false,1)
		  local kk = Rotate(self,dt,false,2)
          if not kk and not self.pickup then self.zangeMove = nil; self.zange = nil;end
       else
                   Rotate(self,dt,true,1)
		  local kk = Rotate(self,dt,true,2)
          if kk and not self.pickup then self.zangeMove = true; self.zange = nil;end	   
	   end 
	end; 		

	
	--Pickup in Arbeitsstellung / Transportstellung
	if self.pickup then
	   if self.down then
	     Rotate(self,dt,false,6)
		 local check = Rotate(self,dt,true,5)
		 if self.Attacher[11].count ~=0 then Move(self,dt/2.5,false,14);self.retour = true;end
		 if check then self.down = nil; self.pickup = nil;end
	   else
		 local check = Rotate(self,dt,false,5)
		 if self.retour then Move(self,dt/2.5,true,14);end
		 if not check then self.pickup = nil; self.down = true; self.retour = nil;end
	   end
    end	   


	if self.arm == true  then	--Ballen aufnehmen in Pos 1 schieben
			    local check= Rotate(self,dt,self.arm,6)
		if check then
			if self.Attacher[11].count == 0 then
				   local check = Move(self,dt,self.arm,4)
				     if check then
					  self:create1(0,2)
					 end; 
			else
				     Move(self,dt,self.arm,4)
				local x, y, z = getTranslation(self.translationParts[4].node)
				if x < -0.53001 then
				  local check = Move(self,dt,false,14)
				  if not check then self:create1(0,2);end;
		        end;
		    end; 
        end;
  
	elseif self.down == true and self.arm == "moveDown" then --Aufnahme in Arbeitsstellung
			
			    local kk = Move(self,dt,false,4)
				local ll = Rotate(self,dt,false,6)
				if not kk and not ll then
					self.arm = nil
				end; 	
    end;
		
		
	
				
	if self.transfer ~= nil then
			if self.Attacher[11].count ~= 0 then
			local parent
		    local joint = nil
			local trans = nil
		    local count = self.Attacher[11].count
				for i=2,10 do 
                      if getParent(self.Attacher[i].object.node) == self.rotationParts[7].node then
				      joint = i;
					break;
				    end;
				end;
				for i=1,table.getn(self.translationParts) do
				 if self.translationParts[i].node == self.Attacher[joint].object.node then
                 trans = i;
                 break;				 
				end;
				end;
			local jcount = self.Attacher[joint].count
          		for ii=1,count do
				local xx = jcount + count
				link(self.Attacher[joint].object.node,self.Attacher[11].attachedObject[ii]);
				if count == 1 then 
				local x,y,z = getTranslation(self.Attacher[11].attachedObject[ii])
				setTranslation(self.Attacher[11].attachedObject[ii],x,y,z-1.82)
				end
				if xx > 2 then
				local x,y,z = getTranslation(self.Attacher[11].attachedObject[ii])
				setTranslation(self.Attacher[11].attachedObject[ii],x-1.15,y,z)
				end;
				self.Attacher[joint].attachedObject[xx] = self.Attacher[11].attachedObject[ii];
				self.Attacher[11].attachedObject[ii] = nil;
				self.Attacher[11].count = self.Attacher[11].count - 1
				self.Attacher[joint].count = self.Attacher[joint].count + 1
				end;			
			
			setTranslation(self.Attacher[11].object.node,-0.91,0.26,3.01)
			self.schieber = {self.Attacher[joint].count, trans}

				end;
			self.transfer = nil;
	end;			
				
				
				
	if type(self.schieber) == "table" then
		local count = self.schieber[1]				
	    local joint = self.schieber[2]				
		  if count == 4 or self.entladen then
		  self.kipp = {false,joint}
		  end;
		local pos = {}
		pos[1] = {}
		pos[2] = {}
        pos[3] = {}
		pos[4] = {}
		pos[2].ttime = 660
		pos[4].ttime = 400
		pos[2].schieber = 2.42;
		pos[2].joint = 1.86;
		pos[4].schieber = 2.87;
		pos[4].joint = 1.16;
		pos[1].schieber = 1.72
		pos[1].joint = 1.16
		pos[3].schieber = 2.87
		pos[3].joint = 1.16
		pos[3].ttime = 400
		pos[1].ttime = 800
		
				
		if limit == nil then
	        local check = Move(self,dt,true,1)				 
			if check then 
				limit = true;				
				local x,y,z =getTranslation(self.translationParts[joint].node)
				self.translationParts[joint].minTrans = {x,y,z}
				local x,y,z =getTranslation(self.translationParts[1].node)
				self.translationParts[1].minTrans ={x,y,z}
			end;
	    else 
		    self.translationParts[1].maxTrans[3] = pos[count].schieber
		    self.translationParts[1].transTime = pos[count].ttime;	
		    self.translationParts[joint].maxTrans[3] = pos[count].joint
		    self.translationParts[joint].transTime = pos[count].ttime;
		    local kk = Move(self,dt,true,1);
		    local ll = Move(self,dt,true,joint);				  
				 if kk and ll then
                    limit = nil				 
				    self.schieber = false				
				 end;
		end;
	elseif self.schieber == false then
										
		self.translationParts[1].minTrans[3] = 3.75
		local check = Move(self,dt,false,1)
	    if not check then
		  self.translationParts[1].transTime = 100
		  self.translationParts[1].maxTrans[3] = 3.57
		  self.schieber = nil; 
	    end; 
	end; 
				

		
		
	if type(self.kipp) == "table" and self.schieber == nil and self.down then
		local joint = self.kipp[2]
		local set = self.kipp[1]
		self:TischKippen(dt,joint,set)
	elseif self.kipp == "moveDown" and not self.entladen then
		local kk = Rotate(self,dt,false,3)
		local ll = Rotate(self,dt,false,7)
		
		if not kk and not ll then self.kipp = nil ;end;
	end;		
		
		
		
		
		-- create attach start
	if self.on == true then
		local nearestObject
		local index
		if self.Attacher[1].attachedObject[1] == nil then
		  nearestObject,index = ObjectInRange(self);
		  self.Attacher[1].objectInRange = nearestObject;
		  if self.Attacher[1].objectInRange ~= nil then
			self.Attacher[1].objectAttachable = true;
			self:create1(self.Attacher[1].objectInRange,1)
			table.remove(g_currentMission.itemsToSave,index)
		  else
			self.Attacher[1].objectAttachable = false;
		  end;
		  
		end;
       
	end;		 
		
	end; 
	
end; --Update Ende





function ArcusinAutoStack:create1(object,attacher)
if attacher == 1 then
    for i=2,10 do
  
	   if getParent(self.Attacher[i].object.node) == self.rotationParts[7].node and self.Attacher[i].count < 4 then
		   localObject = self.Attacher[1].object;
		   setRigidBodyType(object,"none")
		   link(localObject.node, object);
		   setRotation(object, 0,0,0);
		   setTranslation(object, 0,0,0)
			self.Attacher[1].attachedObject[1] = object
			self.arm = true; 
			self.sound3 = true
			self.ps1On = true
	        break;
	    end;
    end;
 
elseif attacher == 2 then
   local obj = self.Attacher[1].attachedObject[1]
   link(self.Attacher[11].object.node, obj);
   
    if self.Attacher[11].count == 0 then
	 setRotation(obj, 0,0,0);
     setTranslation(obj, 0,0,0)
	 self.Attacher[11].attachedObject[1] = obj;
	else
	 setRotation(obj, 0,0,0);
     setTranslation(obj,0,0,-1.82)
     self.Attacher[11].attachedObject[2] = obj;
	 self.transfer = true
    end;
   self.Attacher[1].attachedObject[1] = nil
   self.Attacher[11].count = self.Attacher[11].count + 1
   self.fillLevel = self.fillLevel + 1
   self.arm = "moveDown"
end
end;
 	
	

function ArcusinAutoStack:TischKippen(dt,joint,set)
      
local maxi 
local helper
local index
		
for i=1,table.getn(self.helper) do
	local x = getNumOfChildren(self.helper[i])
	if x == 0 then helper = self.helper[i]; index = i;  break; end
end;
		
if not set then 
	local x,y,z = getTranslation(self.translationParts[joint].node)
	self.translationParts[joint].maxTrans[3] = 0.78
	self.translationParts[joint].minTrans = {x,y,z}
	if index ~= 1 then
		local x,y,z = getTranslation(self.translationParts[2].node)
		self.translationParts[2].maxTrans[3] = z-0.75
		self.translationParts[2].minTrans = {x,y,z}
		self.translationParts[2].transTime = self.rotationParts[3].rotTime
	end
    local x,y,z = getTranslation(self.translationParts[15].node)
    self.translationParts[15].maxTrans[3] = z-0.75
	self.translationParts[15].minTrans = {x,y,z}
	self.translationParts[15].transTime = self.rotationParts[3].rotTime
	self.translationParts[joint].transTime = self.rotationParts[3].rotTime
	self.kipp[1] = true
else
	local kk = Rotate(self,dt,true,3)
	Rotate(self,dt,true,7)
    Move(self,dt,true,joint)
	local ll = Move(self,dt,true,15)
	if index ~=1 then Move(self,dt,true,2);end
	if kk and ll then maxi = true ;end;
end
		
if maxi then
	link(helper,self.translationParts[joint].node)
	setTranslation(self.translationParts[joint].node,0,0,0)
	self.kipp = "moveDown"
end;
	
end

function ArcusinAutoStack:Entladen(dt,obj,typ)
  if typ == 1 then
    local root = getRootNode()
    local straw = "data/maps/models/objects/strawbale/strawbaleBaler.i3d"
    local hay = "data/maps/models/objects/strawbale/haybaleBaler.i3d"
    local joint = self.rotationParts[7].node
    local node
    local file
    local count
    if g_currentMission.itemsToSave == nil then g_currentMission.itemsToSave = {}; end
      for i=1,table.getn(obj) do
        node = obj[i].node
        co = obj[i].count
         for x=1,co do
         child = getChildAt(node,0)
         name = getName(child)
         if name == "strawbaleBaler" then file = straw;end
         if name == "haybaleBaler" then file = hay;end
         local x,y,z = getWorldTranslation(child)
         local rx,ry,rz = getWorldRotation(child)
         link(root,child)
		 setTranslation(child,x,y,z)
		 setRotation(child,rx,ry,rz)
		 setRigidBodyType(child,"Dynamic")
		 table.insert(g_currentMission.itemsToSave,{["class"]="MT",["i3dFilename"]=file,["node"]=child,["childIndex"]=0})
		 end
        link(joint,node)
        setTranslation(node,0.91,0.26,3.01)
      end
    self.fillLevel = 0
    for i=1,table.getn(self.Attacher) do
      self.Attacher[i].count = 0
	    for x=1,4 do
	     self.Attacher[i].attachedObject[x] = nil
    end;end
  end
end
	

function ObjectInRange(self)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 3.0;
	local objectCopy = self.Attacher[1].object;	
	local px, py, pz = getWorldTranslation(objectCopy.node);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
		if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") then
		local vx, vy, vz = getWorldTranslation(itemNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		    if distance < nearestDistance then
			index = i
			nearestObject = itemNode
			nearestDistance = distance
			end;
			
		end;end
	end;
return nearestObject, index
end;



function ArcusinAutoStack:onDetach()
    setRigidBodyType(self.stuetze,"dynamic")
	self.st = false;
	end; 	
	
function ArcusinAutoStack:onAttach()
	setRigidBodyType(self.stuetze,"none")
	self.st = true;
	end; 	




function ArcusinAutoStack:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
   self.fillLevel = getXMLFloat(xmlFile, key.."#fillLevel");
   local itemkey = key..".items"
   local count = Utils.getNoNil(getXMLInt(xmlFile, itemkey.."#count"),0)
   if count ~= 0 then
    for i=1,count do
     self.itemsToSave[i] ={}
     local key = itemkey..".item"..i
     local name = getXMLString(xmlFile, key.."#filename")
     local x,y,z = Utils.getVectorFromString(getXMLString(xmlFile, key.."#position"))
     local parent = getXMLInt(xmlFile, key.."#parent")
     self.itemsToSave[i].name = name
     self.itemsToSave[i].pos = {x,y,z}
     self.itemsToSave[i].parent = parent
     self:loadItems(i)
    end;end
	self.fillLevel = table.getn(self.itemsToSave)
  self.itemsToSave = nil
return BaseMission.VEHICLE_LOAD_OK
end

function ArcusinAutoStack:getSaveAttributesAndNodes(nodeIdent)
 local items ={}
 local straw = "data/maps/models/objects/strawbale/strawbaleBaler.i3d"
 local hay = "data/maps/models/objects/strawbale/haybaleBaler.i3d"
 for ii=2,10 do
   local node = self.Attacher[ii].object.node
   local count = getNumOfChildren(node)
   if count == 4 then
   for xx=1,count do
     local child = getChildAt(node,xx-1)
     local name = getName(child)
     if name == "strawbaleBaler" then name = straw;elseif name == "haybaleBaler" then name = hay;end
     table.insert(items,{node=child,parent=ii-1,name=name})
   end;end;
 end
 local attributes = ""
 local i=0
 if items ~= nil then i= table.getn(items); end
 local nodes = ""
 nodes = nodes..nodeIdent..'<items count="'..i..'">'
if i ~= 0 then
 nodes = nodes.."\n";
for xx=1,i do
  local name = items[xx].name
  local x,y,z = getTranslation(items[xx].node)
  local id = items[xx].parent
  if xx > 1 then nodes = nodes.."\n" ;end
  nodes = nodes..nodeIdent..'<item'..xx..' filename="'..name..'" position="'..x..' '..y..' '..z..'" parent="'..id..'" />' 
end;end
 nodes = nodes.."\n";
 nodes = nodes..nodeIdent..'</items>'
 return attributes,nodes
end 


function ArcusinAutoStack:loadItems(id)
  local item = self.itemsToSave[id]
  local i = item.parent
  local i3dNode = Utils.loadSharedI3DFile(item.name, baseDirectory);
  local itemNode = getChildAt(i3dNode,0)
  local helper = self.helper[i]
  local attacher = self.Attacher[i+1].object.node
  local x,y,z = unpack(item.pos)
  if getParent(attacher) ~= helper then
   link(helper,attacher)
   if i > 1 then
     local x,y,z = getTranslation(self.translationParts[2].node)
     setTranslation(self.translationParts[2].node,x,y,z-0.75)
   end
   local x,y,z = getTranslation(self.translationParts[15].node)
   setTranslation(self.translationParts[15].node,x,y,z-0.75)
   setTranslation(attacher,0,0,0)
   setRotation(attacher,0,1.57,0)
  end
  self.itemsToSave[id].node = itemNode
  setRigidBodyType(itemNode,"none")
  link(attacher,itemNode)
  setTranslation(itemNode,x,y,z)
  setRotation(itemNode,0,0,0)
  delete(i3dNode)
  for c=1,4 do
  if self.Attacher[i+1].attachedObject[c] == nil then
     self.Attacher[i+1].attachedObject[c] = itemNode
     self.Attacher[i+1].count = self.Attacher[i+1].count+1
     break
  end;end
end 


function Time(self,TEIL,z)
local obj = self.translationParts[TEIL]
local def = self.translationParts[TEIL].defaults
local defTime = self.translationParts[TEIL].defaults.transTime
local MAX = obj.maxTrans[z]
local MIN = obj.minTrans[z]
local defMAX = def.maxTrans[z]
local defMIN = def.minTrans[z]
local defma = math.max(defMAX,defMIN)
local defmi = math.min(defMAX,defMIN)
local ma = math.max(MAX,MIN)
local mi = math.min(MAX,MIN)
local multi = defTime/(defma-defmi)
local test = 5*(3-3)
local zeitNeu = multi*(ma-mi)
return zeitNeu
end



function Move(self,dt,bool,i)
self.sound2 =true
local obj = self.translationParts[i]
local minRot = obj.minTrans
local maxRot = obj.maxTrans
local x,y,z = getTranslation(obj.node)
local trans = {x,y,z};
if bool then
 if math.abs(x-maxRot[1]) < 0.0001 and math.abs(y-maxRot[2]) < 0.0001 and math.abs(z-maxRot[3]) < 0.0001 then self.sound2 = nil;return true ;end
 elseif math.abs(x-minRot[1]) < 0.0001 and math.abs(y-minRot[2]) < 0.0001 and math.abs(z-minRot[3]) < 0.0001 then self.sound2 =nil;return false ;end

local newTrans = Utils.getMovedLimitedValues(trans, maxRot, minRot, 3, obj.transTime, dt, not bool);
setTranslation(obj.node, unpack(newTrans)) 
return not bool
end;		  

function Rotate(self,dt,bool,i)
self.sound1 = true
local obj = self.rotationParts[i]
local minRot = obj.minRot
local maxRot = obj.maxRot
local x,y,z = getRotation(obj.node)
local trans = {x,y,z};
if bool then
 if math.abs(x-maxRot[1]) < 0.0001 and math.abs(y-maxRot[2]) < 0.0001 and math.abs(z-maxRot[3]) < 0.0001 then self.sound1 = nil; return true ;end
 elseif math.abs(x-minRot[1]) < 0.0001 and math.abs(y-minRot[2]) < 0.0001 and math.abs(z-minRot[3]) < 0.0001 then self.sound1 = nil; return false ;end
local newTrans = Utils.getMovedLimitedValues(trans, maxRot, minRot, 3, obj.rotTime, dt, not bool);
setRotation(obj.node, unpack(newTrans)) 
return not bool
end;		  

